package cz.vitskalicky.lepsirozvrh.theme

import androidx.compose.ui.graphics.Color
import cz.vitskalicky.lepsirozvrh.BuildConfig

object DefaultRozvrhThemes {
    final val LIGHT = RozvrhTheme(
        isLight = true,
        cABg = Color(0xffFFD54F),
        cAPrimaryText = Color(0xff000000),
        cARoomText = Color(0xff2D3A41),
        cASecondaryText = Color(0xff000000),
        cChngBg = Color(0xffFFD54F),
        cChngPrimaryText = Color(0xff000000),
        cChngRoomText = Color(0xff2D3A41),
        cChngSecondaryText = Color(0xff000000),
        cDivider = Color(0xffEEEEEE),
        cEmptyBg = Color(0xffEEEEEE),
        cError = Color(0xffB00020),
        cHBg = Color(0xffFAFAFA),
        cHPrimaryText = Color(0xff000000),
        cHRoomText = Color(0xff2D3A41),
        cHSecondaryText = Color(0xff000000),
        cHeaderBg = Color(0xffE1E1E1),
        cHeaderPrimaryText = Color(0xff000000),
        cHeaderSecondaryText = Color(0xff000000),
        cHighlight = Color(0xffF9A825),
        cHomework = Color(0xff455A64),
        cInfolineBg = Color(0xff424242),
        cInfolineText = Color(0xffFFFFFF),
        cPrimary = Color(0xffF9A825),
        cSecondary = Color(0xff455A64),
        cSurface = Color(0xffFAFAFA),
        dpDividerWidth = 1.0f,
        dpHighlightWidth = 1.0f,
        dpHomework = 5.0f,
        dpPaddingBottom = 3.0f,
        dpPaddingLeft = 3.0f,
        dpPaddingRight = 3.0f,
        dpPaddingTop = 3.0f,
        dpTextPadding = 2.0f,
        spInfolineTextSize = 12.0f,
        spPrimaryText = 18.0f,
        spSecondaryText = 12.0f,
        customizationLevel = 0,
    )

    final val DARK = RozvrhTheme(
        isLight = false,
        cABg = Color(0xFF8b4d00),
        cAPrimaryText = Color(0xFFFFFFFF),
        cARoomText = Color(0xFFD2D7D9),
        cASecondaryText = Color(0xFFFFFFFF),
        cChngBg = Color(0xFF8b4d00),
        cChngPrimaryText = Color(0xFFFFFFFF),
        cChngRoomText = Color(0xFFD2D7D9),
        cChngSecondaryText = Color(0xFFFFFFFF),
        cDivider = Color(0xFF121212),
        cEmptyBg = Color(0xFF121212),
        cError = Color(0xFFCF6679),
        cHBg = Color(0xFF1F1F1F),
        cHPrimaryText = Color(0xFFFFFFFF),
        cHRoomText = Color(0xFFD2D7D9),
        cHSecondaryText = Color(0xFFFFFFFF),
        cHeaderBg = Color(0xFF393939),
        cHeaderPrimaryText = Color(0xFFFFFFFF),
        cHeaderSecondaryText = Color(0xFFFFFFFF),
        cHighlight = Color(0xFFF9A825),
        cHomework = Color(0xFFF9A825),
        cInfolineBg = Color(0xFF424242),
        cInfolineText = Color(0xFFFFFFFF),
        cPrimary = Color(0xFFF9A825),
        cSecondary = Color(0xFFCFD8DC),
        cSurface = Color(0xFF121212),
        dpDividerWidth = 1.0f,
        dpHighlightWidth = 1.0f,
        dpHomework = 5.0f,
        dpPaddingBottom = 3.0f,
        dpPaddingLeft = 3.0f,
        dpPaddingRight = 3.0f,
        dpPaddingTop = 3.0f,
        dpTextPadding = 2.0f,
        spInfolineTextSize = 12.0f,
        spPrimaryText = 18.0f,
        spSecondaryText = 12.0f,
        customizationLevel = 0,
    )
    final val BLACK = RozvrhTheme(
        isLight = false,
        cABg = Color(0xFF464C4F),
        cAPrimaryText = Color(0xFFFFFFFF),
        cARoomText = Color(0xFFE3E8EB),
        cASecondaryText = Color(0xFFFFFFFF),
        cChngBg = Color(0xFF464C4F),
        cChngPrimaryText = Color(0xFFFFFFFF),
        cChngRoomText = Color(0xFFE3E8EB),
        cChngSecondaryText = Color(0xFFFFFFFF),
        cDivider = Color(0xFF121212),
        cEmptyBg = Color(0xFF121212),
        cError = Color(0xFFCF6679),
        cHBg = Color(0xFF000000),
        cHPrimaryText = Color(0xFFFFFFFF),
        cHRoomText = Color(0xFFE3E8EB),
        cHSecondaryText = Color(0xFFFFFFFF),
        cHeaderBg = Color(0xFF242424),
        cHeaderPrimaryText = Color(0xFFFFFFFF),
        cHeaderSecondaryText = Color(0xFFFFFFFF),
        cHighlight = Color(0xFFF9A825),
        cHomework = Color(0xFFF9A825),
        cInfolineBg = Color(0xFF424242),
        cInfolineText = Color(0xFFFFFFFF),
        cPrimary = Color(0xFFF9A825),
        cSecondary = Color(0xFFCFD8DC),
        cSurface = Color(0xFF000000),
        dpDividerWidth = 1.5f,
        dpHighlightWidth = 1.0f,
        dpHomework = 5.0f,
        dpPaddingBottom = 3.0f,
        dpPaddingLeft = 3.0f,
        dpPaddingRight = 3.0f,
        dpPaddingTop = 3.0f,
        dpTextPadding = 2.0f,
        spInfolineTextSize = 12.0f,
        spPrimaryText = 18.0f,
        spSecondaryText = 12.0f,
        customizationLevel = 0,
    )

    // as visible as possible if debug, hope it is unnoticed in production
    final val UNSPECIFIED = if (BuildConfig.DEBUG)
        RozvrhTheme(
            isLight = false,
            cABg = Color.Magenta,
            cAPrimaryText = Color.Cyan,
            cARoomText = Color.Cyan,
            cASecondaryText = Color.Cyan,
            cChngBg = Color.Magenta,
            cChngPrimaryText = Color.Cyan,
            cChngRoomText = Color.Cyan,
            cChngSecondaryText = Color.Cyan,
            cDivider = Color.Magenta,
            cEmptyBg = Color.Magenta,
            cError = Color.Magenta,
            cHBg = Color.Magenta,
            cHPrimaryText = Color.Cyan,
            cHRoomText = Color.Cyan,
            cHSecondaryText = Color.Cyan,
            cHeaderBg = Color.Magenta,
            cHeaderPrimaryText = Color.Cyan,
            cHeaderSecondaryText = Color.Cyan,
            cHighlight = Color.Magenta,
            cHomework = Color.Magenta,
            cInfolineBg = Color.Magenta,
            cInfolineText = Color.Cyan,
            cPrimary = Color.Magenta,
            cSecondary = Color.Magenta,
            cSurface = Color.Magenta,
            dpDividerWidth = 1.0f,
            dpHighlightWidth = 1.0f,
            dpHomework = 5.0f,
            dpPaddingBottom = 3.0f,
            dpPaddingLeft = 3.0f,
            dpPaddingRight = 3.0f,
            dpPaddingTop = 3.0f,
            dpTextPadding = 2.0f,
            spInfolineTextSize = 12.0f,
            spPrimaryText = 18.0f,
            spSecondaryText = 12.0f,
            customizationLevel = 0,
        ) else LIGHT
}
